import { Actions } from '../interfaces';
import { State } from './state';
import { Subject, Stream, $ } from '../xs';
export declare type Partial<T> = {
    [P in keyof T]?: T[P];
};
export interface pair<S, A> {
    s: S;
    a: A;
}
export declare type StateP<S> = State<S, Partial<S>>;
export interface Machine<E extends Stream, I, S, A> {
    actions?: Actions<I>;
    update$: $<E, State<S, A>>;
}
export declare type PlanS<E extends Stream, I, S, A> = (i: Subject<E, I>) => Machine<E, I, S, A>;
