"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var functor_1 = require("./typeclasses/functor");
var cartesian_1 = require("./typeclasses/cartesian");
var apply_1 = require("./typeclasses/apply");
var flatmap_1 = require("./typeclasses/flatmap");
var applicative_1 = require("./typeclasses/applicative");
var monad_1 = require("./typeclasses/monad");
var typeclasses_1 = require("./typeclasses");
exports.kind = "State";
var State = /** @class */ (function () {
    function State(runState) {
        this.runState = runState;
    }
    State_1 = State;
    State.prototype.runA = function (state) {
        return this.runState(state).a;
    };
    State.prototype.runS = function (state) {
        return this.runState(state).s;
    };
    State.pure = function (a) {
        return new State_1(function (s) { return ({ a: a, s: s }); });
    };
    State.get = function () {
        return new State_1(function (s) { return ({ s: s, a: s }); });
    };
    State.put = function (s) {
        return new State_1(function (_) { return ({ a: undefined, s: s }); });
    };
    State.modify = function (f) {
        return new State_1(function (s) { return ({ a: undefined, s: Object.assign({}, s, f(s)) }); });
    };
    State.prototype.patch = function (f) {
        var _this = this;
        return new State_1(function (state) {
            var _a = _this.runState(state), a = _a.a, s = _a.s;
            var p = f(a, s);
            return {
                a: p, s: Object.assign({}, s, p)
            };
        });
    };
    State = State_1 = __decorate([
        typeclasses_1.datatype(exports.kind),
        __metadata("design:paramtypes", [Function])
    ], State);
    return State;
    var State_1;
}());
exports.State = State;
var StateFunctor = /** @class */ (function () {
    function StateFunctor() {
    }
    StateFunctor.prototype.map = function (f, fa) {
        return new State(function (state) {
            var _a = fa.runState(state), a = _a.a, s = _a.s;
            return { a: f(a), s: s };
        });
    };
    return StateFunctor;
}());
exports.StateFunctor = StateFunctor;
functor_1.Functor.State = new StateFunctor;
var StateCartesian = /** @class */ (function () {
    function StateCartesian() {
    }
    StateCartesian.prototype.product = function (fa, fb) {
        return new State(function (state) {
            var _a = fa.runState(state), a1 = _a.a, s1 = _a.s;
            var _b = fb.runState(s1), a2 = _b.a, s2 = _b.s;
            return { a: [a1, a2], s: s2 };
        });
    };
    return StateCartesian;
}());
exports.StateCartesian = StateCartesian;
cartesian_1.Cartesian.State = new StateCartesian;
var StateApply = /** @class */ (function () {
    function StateApply() {
        this.map = functor_1.Functor.State.map;
        this.product = cartesian_1.Cartesian.State.product;
    }
    StateApply.prototype.ap = function (fab, fa) {
        return new State(function (state) {
            var _a = fab.runState(state), f = _a.a, s1 = _a.s;
            var _b = fa.runState(s1), a = _b.a, s2 = _b.s;
            return { a: f(a), s: s2 };
        });
    };
    return StateApply;
}());
exports.StateApply = StateApply;
apply_1.Apply.State = new StateApply;
var StateApplicative = /** @class */ (function (_super) {
    __extends(StateApplicative, _super);
    function StateApplicative() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pure = State.pure;
        return _this;
    }
    return StateApplicative;
}(StateApply));
exports.StateApplicative = StateApplicative;
applicative_1.Applicative.State = new StateApplicative;
var StateFlatMap = /** @class */ (function (_super) {
    __extends(StateFlatMap, _super);
    function StateFlatMap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StateFlatMap.prototype.flatMap = function (f, fa) {
        return new State(function (state) {
            var _a = fa.runState(state), a = _a.a, s = _a.s;
            return f(a).runState(s);
        });
    };
    return StateFlatMap;
}(StateApplicative));
exports.StateFlatMap = StateFlatMap;
flatmap_1.FlatMap.State = new StateFlatMap;
var StateMonad = /** @class */ (function (_super) {
    __extends(StateMonad, _super);
    function StateMonad() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.flatMap = flatmap_1.FlatMap.State.flatMap;
        return _this;
    }
    return StateMonad;
}(StateApplicative));
exports.StateMonad = StateMonad;
monad_1.Monad.State = new StateMonad;
