"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
function datatype(name) {
    return function (constructor) {
        Reflect.defineMetadata('design:type', name, constructor);
    };
}
exports.datatype = datatype;
function kind(target) {
    if (isPrimitive(target))
        return target.constructor.name;
    return Reflect.getMetadata('design:type', target.constructor);
}
exports.kind = kind;
datatype('Array')(Array);
datatype('Object')(Object);
datatype('Promise')(Promise);
function isPrimitive(a) {
    return ['string', 'number', 'symbol', 'boolean'].indexOf(typeof a) >= 0;
}
