export declare type instanceKey = keyof S;
export declare type S = typeof Semigroup;
export declare type SemigroupInstance = keyof typeof Semigroup;
export declare type SemigroupInstanceType = typeof Semigroup[SemigroupInstance]['_T'];
export interface Semigroup<A> {
    _T: A;
    concat(a: any, b: any): A;
}
export declare class NumberSemigroup implements Semigroup<number> {
    _T: number;
    concat(a: any, b: any): number;
}
export declare class ObjectSemigroup implements Semigroup<object> {
    _T: object;
    concat(a: any, b: any): object;
}
export declare class PromiseSemigroup implements Semigroup<Promise<SemigroupInstanceType>> {
    _T: Promise<any>;
    concat(a: any, b: any): Promise<SemigroupInstanceType>;
}
export declare class StringSemigroup implements Semigroup<string> {
    _T: string;
    concat(a: any, b: any): string;
}
export declare class ArraySemigroup<A> implements Semigroup<Array<A>> {
    _T: Array<A>;
    concat(a: Array<A>, b: Array<A>): Array<A>;
}
export declare namespace Semigroup {
    let Number: NumberSemigroup;
    let String: StringSemigroup;
    let Array: ArraySemigroup<any>;
    let Object: ObjectSemigroup;
    let Promise: PromiseSemigroup;
}
export declare function concat<A extends SemigroupInstanceType>(a: A, b: A): A;
