"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var NumberSemigroup = /** @class */ (function () {
    function NumberSemigroup() {
    }
    NumberSemigroup.prototype.concat = function (a, b) {
        return a + b;
    };
    return NumberSemigroup;
}());
exports.NumberSemigroup = NumberSemigroup;
var ObjectSemigroup = /** @class */ (function () {
    function ObjectSemigroup() {
    }
    ObjectSemigroup.prototype.concat = function (a, b) {
        return Object.assign({}, a, b);
    };
    return ObjectSemigroup;
}());
exports.ObjectSemigroup = ObjectSemigroup;
var PromiseSemigroup = /** @class */ (function () {
    function PromiseSemigroup() {
    }
    PromiseSemigroup.prototype.concat = function (a, b) {
        return Promise.all([a, b]).then(function (_a) {
            var a = _a[0], b = _a[1];
            return concat(a, b);
        });
    };
    return PromiseSemigroup;
}());
exports.PromiseSemigroup = PromiseSemigroup;
var StringSemigroup = /** @class */ (function () {
    function StringSemigroup() {
    }
    StringSemigroup.prototype.concat = function (a, b) {
        return a + b;
    };
    return StringSemigroup;
}());
exports.StringSemigroup = StringSemigroup;
var ArraySemigroup = /** @class */ (function () {
    function ArraySemigroup() {
    }
    ArraySemigroup.prototype.concat = function (a, b) {
        return a.concat(b);
    };
    return ArraySemigroup;
}());
exports.ArraySemigroup = ArraySemigroup;
var Semigroup;
(function (Semigroup) {
    Semigroup.Number = new NumberSemigroup;
    Semigroup.String = new StringSemigroup;
    Semigroup.Array = new ArraySemigroup();
    Semigroup.Object = new ObjectSemigroup;
    Semigroup.Promise = new PromiseSemigroup;
})(Semigroup = exports.Semigroup || (exports.Semigroup = {}));
function concat(a, b) {
    var instance = Semigroup[_1.kind(a)];
    return instance.concat(a, b);
}
exports.concat = concat;
