"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var functor_1 = require("./typeclasses/functor");
var cartesian_1 = require("./typeclasses/cartesian");
var apply_1 = require("./typeclasses/apply");
var flatmap_1 = require("./typeclasses/flatmap");
var applicative_1 = require("./typeclasses/applicative");
var semigroup_1 = require("./typeclasses/semigroup");
var monad_1 = require("./typeclasses/monad");
var xs_1 = require("../xs");
var fantasyx_1 = require("./fantasyx");
var state_1 = require("./state");
var typeclasses_1 = require("./typeclasses");
var Xstream = /** @class */ (function () {
    function Xstream(streamS) {
        this.streamS = streamS;
    }
    Xstream_1 = Xstream;
    Xstream.prototype.filter = function (f) {
        return new Xstream_1(monad_1.Monad.State.map(function (sa) { return xs_1.streamOps.filter(f, sa); }, this.streamS));
    };
    Xstream.fromIntent = function () {
        return new Xstream_1(new state_1.State(function (intent$) { return ({
            s: intent$,
            a: intent$
        }); }));
    };
    Xstream.fromEvent = function (type, name, defaultValue) {
        return new Xstream_1(new state_1.State(function (intent$) { return ({
            s: intent$,
            a: xs_1.streamOps.merge(typeof defaultValue != 'undefined' ? xs_1.streamOps.just(defaultValue) : xs_1.streamOps.empty(), xs_1.streamOps.map(function (e) { return e.target.value; }, xs_1.streamOps.filter(function (e) {
                var target = e.target;
                return target.tagName == 'INPUT' && e.type == type && target.name == name;
            }, intent$)))
        }); }));
    };
    Xstream.fromPromise = function (p) {
        return new Xstream_1(new state_1.State(function (intent$) { return ({
            s: intent$,
            a: xs_1.streamOps.fromPromise(p)
        }); }));
    };
    Xstream.prototype.toFantasyX = function () {
        var _this = this;
        return new fantasyx_1.FantasyX(new state_1.State(function (intent$) {
            var state$ = _this.streamS.runA(intent$);
            return {
                s: intent$,
                a: functor_1.map(function (a) { return applicative_1.Applicative.State.pure(a); }, state$)
            };
        }));
    };
    Xstream = Xstream_1 = __decorate([
        typeclasses_1.datatype('Xstream'),
        __metadata("design:paramtypes", [state_1.State])
    ], Xstream);
    return Xstream;
    var Xstream_1;
}());
exports.Xstream = Xstream;
var XstreamFunctor = /** @class */ (function () {
    function XstreamFunctor() {
    }
    XstreamFunctor.prototype.map = function (f, fa) {
        return new Xstream(monad_1.Monad.State.map(function (sa) { return functor_1.map(f, sa); }, fa.streamS));
    };
    return XstreamFunctor;
}());
exports.XstreamFunctor = XstreamFunctor;
functor_1.Functor.Xstream = new XstreamFunctor;
var XstreamCartesian = /** @class */ (function () {
    function XstreamCartesian() {
    }
    XstreamCartesian.prototype.product = function (fa, fb) {
        return new Xstream(flatmap_1.FlatMap.State.flatMap(function (s1) { return (functor_1.Functor.State.map(function (s2) { return (cartesian_1.product(s1, s2)); }, fb.streamS)); }, fa.streamS));
    };
    return XstreamCartesian;
}());
exports.XstreamCartesian = XstreamCartesian;
cartesian_1.Cartesian.Xstream = new XstreamCartesian;
var XstreamApply = /** @class */ (function () {
    function XstreamApply() {
        this.map = functor_1.Functor.Xstream.map;
        this.product = cartesian_1.Cartesian.Xstream.product;
    }
    XstreamApply.prototype.ap = function (fab, fa) {
        return new Xstream(flatmap_1.FlatMap.State.flatMap(function (s1) { return (functor_1.Functor.State.map(function (s2) { return (functor_1.map((function (_a) {
            var a = _a[0], b = _a[1];
            return a(b);
        }), cartesian_1.product(s1, s2))); }, fa.streamS)); }, fab.streamS));
    };
    return XstreamApply;
}());
exports.XstreamApply = XstreamApply;
apply_1.Apply.Xstream = new XstreamApply;
var XstreamFlatMap = /** @class */ (function (_super) {
    __extends(XstreamFlatMap, _super);
    function XstreamFlatMap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    XstreamFlatMap.prototype.flatMap = function (f, fa) {
        return new Xstream(flatmap_1.FlatMap.State.flatMap(function (a$) { return (functor_1.map(function (i$) {
            var sdf = function (a) { return f(a).streamS.runA(i$); };
            return flatmap_1.flatMap(sdf, a$);
        }, state_1.State.get())); }, fa.streamS));
    };
    return XstreamFlatMap;
}(XstreamApply));
exports.XstreamFlatMap = XstreamFlatMap;
flatmap_1.FlatMap.Xstream = new XstreamFlatMap;
var XstreamApplicative = /** @class */ (function (_super) {
    __extends(XstreamApplicative, _super);
    function XstreamApplicative() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    XstreamApplicative.prototype.pure = function (v) {
        return new Xstream(applicative_1.Applicative.State.pure(xs_1.streamOps.just(v)));
    };
    return XstreamApplicative;
}(XstreamApply));
exports.XstreamApplicative = XstreamApplicative;
applicative_1.Applicative.Xstream = new XstreamApplicative;
var XstreamMonad = /** @class */ (function (_super) {
    __extends(XstreamMonad, _super);
    function XstreamMonad() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.flatMap = flatmap_1.FlatMap.Xstream.flatMap;
        return _this;
    }
    return XstreamMonad;
}(XstreamApplicative));
exports.XstreamMonad = XstreamMonad;
monad_1.Monad.Xstream = new XstreamMonad;
var XstreamSemigroup = /** @class */ (function () {
    function XstreamSemigroup() {
    }
    XstreamSemigroup.prototype.concat = function (fa, fb) {
        return functor_1.Functor.Xstream.map(function (_a) {
            var a = _a[0], b = _a[1];
            return semigroup_1.concat(a, b);
        }, cartesian_1.Cartesian.Xstream.product(fa, fb));
    };
    return XstreamSemigroup;
}());
exports.XstreamSemigroup = XstreamSemigroup;
semigroup_1.Semigroup.Xstream = new XstreamSemigroup;
