import { Stream as MostStream } from 'most';
import { Functor } from '../fantasy/typeclasses/functor';
import { Cartesian } from '../fantasy/typeclasses/cartesian';
import { Apply } from '../fantasy/typeclasses/apply';
import { Monad } from '../fantasy/typeclasses/monad';
export declare const kind = "MostStream";
export declare type kind = typeof kind;
declare module '.' {
    interface S_<A> {
        'MostStream': MostStream<A>;
    }
}
declare module '../fantasy/typeclasses' {
    interface _<A> {
        'MostStream': MostStream<A>;
    }
}
export declare class MostFunctor implements Functor<kind> {
    map<A, B>(f: (a: A) => B, fa: MostStream<A>): MostStream<B>;
}
declare module '../fantasy/typeclasses/functor' {
    namespace Functor {
        let MostStream: MostFunctor;
    }
}
export declare class MostCartesian implements Cartesian<kind> {
    product<A, B>(fa: MostStream<A>, fb: MostStream<B>): MostStream<[A, B]>;
}
declare module '../fantasy/typeclasses/cartesian' {
    namespace Cartesian {
        let MostStream: MostCartesian;
    }
}
export declare class MostApply implements Apply<kind> {
    ap<A, B>(fab: MostStream<(a: A) => B>, fa: MostStream<A>): MostStream<B>;
    map: <A, B>(f: (a: A) => B, fa: MostStream<A>) => MostStream<B>;
    product: <A, B>(fa: MostStream<A>, fb: MostStream<B>) => MostStream<[A, B]>;
}
declare module '../fantasy/typeclasses/apply' {
    namespace Apply {
        let MostStream: MostApply;
    }
}
export declare class MostFlatMap extends MostApply {
    flatMap<A, B>(f: (a: A) => MostStream<B>, fa: MostStream<A>): MostStream<B>;
}
declare module '../fantasy/typeclasses/flatmap' {
    namespace FlatMap {
        let MostStream: MostFlatMap;
    }
}
export declare class MostApplicative extends MostApply {
    pure<A>(v: A): MostStream<A>;
}
declare module '../fantasy/typeclasses/applicative' {
    namespace Applicative {
        let MostStream: MostApplicative;
    }
}
export declare class MostMonad implements Monad<kind> {
    flatMap: <A, B>(f: (a: A) => MostStream<B>, fa: MostStream<A>) => MostStream<B>;
    map: <A, B>(f: (a: A) => B, fa: MostStream<A>) => MostStream<B>;
    ap: <A, B>(fab: MostStream<(a: A) => B>, fa: MostStream<A>) => MostStream<B>;
    pure: <A>(v: A) => MostStream<A>;
    product: <A, B>(fa: MostStream<A>, fb: MostStream<B>) => MostStream<[A, B]>;
}
declare module '../fantasy/typeclasses/monad' {
    namespace Monad {
        let MostStream: MostMonad;
    }
}
export declare const URI = "Stream";
export declare type URI = typeof URI;
