import { Observable as RxStream } from '@reactivex/rxjs/dist/cjs/Observable';
import '@reactivex/rxjs/dist/cjs/add/operator/map';
import '@reactivex/rxjs/dist/cjs/add/operator/merge';
import '@reactivex/rxjs/dist/cjs/add/operator/mergeMap';
import '@reactivex/rxjs/dist/cjs/add/operator/scan';
import '@reactivex/rxjs/dist/cjs/add/operator/catch';
import '@reactivex/rxjs/dist/cjs/add/operator/filter';
import '@reactivex/rxjs/dist/cjs/add/observable/empty';
import '@reactivex/rxjs/dist/cjs/add/observable/of';
import '@reactivex/rxjs/dist/cjs/add/observable/fromPromise';
import '@reactivex/rxjs/dist/cjs/add/observable/combineLatest';
import { Functor } from '../fantasy/typeclasses/functor';
import { Cartesian } from '../fantasy/typeclasses/cartesian';
import { Apply } from '../fantasy/typeclasses/apply';
import { Monad } from '../fantasy/typeclasses/monad';
export declare const kind = "RxStream";
export declare type kind = typeof kind;
declare module '.' {
    interface S_<A> {
        'RxStream': RxStream<A>;
    }
}
declare module '../fantasy/typeclasses' {
    interface _<A> {
        'RxStream': RxStream<A>;
    }
}
export declare class RxFunctor implements Functor<kind> {
    map<A, B>(f: (a: A) => B, fa: RxStream<A>): RxStream<B>;
}
declare module '../fantasy/typeclasses/functor' {
    namespace Functor {
        let RxStream: RxFunctor;
    }
}
export declare class RxCartesian implements Cartesian<kind> {
    product<A, B>(fa: RxStream<A>, fb: RxStream<B>): RxStream<[A, B]>;
}
declare module '../fantasy/typeclasses/cartesian' {
    namespace Cartesian {
        let RxStream: RxCartesian;
    }
}
export declare class RxApply implements Apply<kind> {
    ap<A, B>(fab: RxStream<(a: A) => B>, fa: RxStream<A>): RxStream<B>;
    map: <A, B>(f: (a: A) => B, fa: RxStream<A>) => RxStream<B>;
    product: <A, B>(fa: RxStream<A>, fb: RxStream<B>) => RxStream<[A, B]>;
}
declare module '../fantasy/typeclasses/apply' {
    namespace Apply {
        let RxStream: RxApply;
    }
}
export declare class RxFlatMap extends RxApply {
    flatMap<A, B>(f: (a: A) => RxStream<B>, fa: RxStream<A>): RxStream<B>;
}
declare module '../fantasy/typeclasses/flatmap' {
    namespace FlatMap {
        let RxStream: RxFlatMap;
    }
}
export declare class RxApplicative extends RxApply {
    pure<A>(v: A): RxStream<A>;
}
declare module '../fantasy/typeclasses/applicative' {
    namespace Applicative {
        let RxStream: RxApplicative;
    }
}
export declare class RxMonad implements Monad<kind> {
    flatMap: <A, B>(f: (a: A) => RxStream<B>, fa: RxStream<A>) => RxStream<B>;
    map: <A, B>(f: (a: A) => B, fa: RxStream<A>) => RxStream<B>;
    ap: <A, B>(fab: RxStream<(a: A) => B>, fa: RxStream<A>) => RxStream<B>;
    pure: <A>(v: A) => RxStream<A>;
    product: <A, B>(fa: RxStream<A>, fb: RxStream<B>) => RxStream<[A, B]>;
}
declare module '../fantasy/typeclasses/monad' {
    namespace Monad {
        let RxStream: RxMonad;
    }
}
export declare const URI = "@reactivex/rxjs";
export declare type URI = typeof URI;
